VERSION 5.00
Begin VB.UserControl ColCombo 
   BackStyle       =   0  'Transparent
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "ColCombo.ctx":0000
End
Attribute VB_Name = "ColCombo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'                             ComboBox
'                             :
'                            Felix Macintosh
'                               (The trick)
'                             2014
'
Dim WithEvents cboTest As ComboBox
Attribute cboTest.VB_VarHelpID = -1
'Default Property Values:

Const m_def_Text = "Write"
Const cTwip = 15
'Property Variables:
Dim m_DefColor As Long
Dim dic As Dictionary
Dim m_Text As String
'Event Declarations:
Event Click()
Event Change()

Private Sub cboTest_Change()
    RaiseEvent Change
End Sub

Private Sub cboTest_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_Show()
    AddColor DefColor, Text
    cboTest.Visible = True
End Sub
Public Function ColorExist(ByVal Col As Long) As Boolean
    '    
    ColorExist = dic.Exists(Col)
End Function

Public Sub Refresh() '
    cboTest.Refresh
End Sub

Public Sub RemoveItem(ByVal Index%)
    ' 
    '
    On Error Resume Next
    cboTest.RemoveItem (Index)
End Sub


Public Function AddColor&(ByVal Col As Long, Optional ByVal Name$, Optional Forward As Boolean)
    ' / 
    ':  //  //   
    Dim f&, NewCol As Long
    
    NewCol = IIf(Col < 0, GetSysColor(Col And &HFFFF&), Col)
    
    If dic.Exists(NewCol) Then
        AddColor = dic(NewCol)
        cboTest.List(AddColor) = Name
        cboTest.ListIndex = AddColor
        Debug.Print AddColor
    ElseIf Forward Then
        cboTest.AddItem ""
        For f = cboTest.NewIndex To 1 Step -1
            cboTest.itemData(f) = cboTest.itemData(f - 1)
            cboTest.List(f) = cboTest.List(f - 1)
            dic(cboTest.itemData(f)) = f
        Next
        cboTest.itemData(0) = NewCol
        cboTest.List(0) = Name
        dic(NewCol) = 0
        AddColor = 0
    Else
        cboTest.AddItem Name
        cboTest.itemData(cboTest.NewIndex) = NewCol
        AddColor = cboTest.NewIndex
    End If
    ListIndex = AddColor
End Function


Public Property Let DefColor(ByVal Col As OLE_COLOR)
    m_DefColor = Col
    m_Text = String(8, "0")
    Mid$(m_Text, 9 - Len(Hex(Col))) = Hex(Col)
    cboTest.List(0) = m_Text
    AddColor Col, m_Text
    PropertyChanged "DefColor"
End Property


Private Sub UserControl_Initialize()
    Set dic = New Dictionary
    Set cboTest = modSubclass.CreateOwnerdrawCombo(UserControl.Controls, "cboTest")
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    cboTest.Move 0, 0
    With UserControl
        .Height = (cTwip * 21)
        cboTest.Width = .ScaleWidth
    End With
End Sub

Public Property Get DefColor() As OLE_COLOR
Attribute DefColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    DefColor = m_DefColor
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_DefColor = vbWhite
    m_Text = m_def_Text
    cboTest.ListIndex = cboTest.ListIndex
    Set cboTest.Font = Ambient.Font
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_DefColor = PropBag.ReadProperty("DefColor", vbWhite)
    m_Text = PropBag.ReadProperty("Text", m_def_Text)
    cboTest.ListIndex = PropBag.ReadProperty("ListIndex", cboTest.ListIndex)
    Set cboTest.Font = PropBag.ReadProperty("Font", Ambient.Font)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("DefColor", m_DefColor, vbWhite)
    Call PropBag.WriteProperty("Text", m_Text, m_def_Text)
    Call PropBag.WriteProperty("ListIndex", cboTest.ListIndex, cboTest.ListIndex)
    Call PropBag.WriteProperty("Font", cboTest.Font, Ambient.Font)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,Write
Public Property Get Text() As String
Attribute Text.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Text = m_Text
End Property

Public Property Let Text(ByVal New_Text As String)
    On Error Resume Next
    cboTest.List(cboTest.ListIndex) = New_Text
    m_Text = New_Text
    PropertyChanged "Text"
End Property

Public Sub Clear()
    cboTest.Clear
End Sub

Public Property Get ListIndex() As Long
Attribute ListIndex.VB_MemberFlags = "400"
    ListIndex = cboTest.ListIndex
End Property

Public Property Let ListIndex(ByVal New_ListIndex As Long)
    On Error Resume Next
    cboTest.ListIndex = New_ListIndex
    PropertyChanged "ListIndex"
End Property
Public Property Get NewIndex() As Long
    NewIndex = cboTest.NewIndex
End Property
Public Property Get ListCount() As Long
Attribute ListCount.VB_MemberFlags = "400"
    ListCount = cboTest.ListCount
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Font.VB_UserMemId = -512
    Set Font = cboTest.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set cboTest.Font = New_Font
    PropertyChanged "Font"
End Property
